<template>
  <el-select
    v-model="selected"
    class="semester-select"
    :placeholder="placeholder"
    filterable
    :clearable="clearable"
    :disabled="disabled"
    @change="select"
  >
    <el-option
      v-for="item in optionList"
      :key="item.id"
      :value="item.id"
      :label="item.name"
    >
    </el-option>
  </el-select>
</template>

<script>
import { unitQueryByType } from "../../modules/base/api";

export default {
  name: "semester-select",
  props: {
    disabled: { type: Boolean, default: false },
    placeholder: { type: String, default: "请选择学期" },
    value: { type: [Number, String], default: "" },
    clearable: { type: Boolean, default: true },
    defaultSelectInUsed: { type: Boolean, default: false }
  },
  data() {
    return {
      optionList: [],
      selected: ""
    };
  },
  watch: {
    value: {
      immediate: true,
      handler(val) {
        this.selected = val;
      }
    }
  },
  created() {
    this.search();
  },
  methods: {
    async search() {
      this.optionList = [];

      const res = await unitQueryByType({}, "SEMESTER");
      this.optionList = res;

      if (this.defaultSelectInUsed) this.selectDefault();
    },
    select() {
      this.$emit("input", this.selected);
      this.$emit(
        "change",
        this.optionList.find(item => item.id === this.selected)
      );
    },
    selectDefault() {
      const defaultCollege = this.optionList.find(item => item.inUsed);
      if (defaultCollege) {
        this.selected = defaultCollege.id;
        this.select();
      }
    }
  }
};
</script>
